Bug 715271 - AJP Proxy: default Satellite setup will not work in an IPv6 only environment
Summary: AJP Proxy: default Satellite setup will not work in an IPv6 only environment
Keywords:
Status: CLOSED CURRENTRELEASE
Alias: None
Product: Red Hat Satellite 5
Classification: Red Hat
Component: Server
Version: 540
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Milan Zázrivec
QA Contact: Pavel Studeník
URL:
Whiteboard:
Depends On:
Blocks: sat550-ipv6
TreeView+ depends on / blocked
 
Reported: 2011-06-22 11:57 UTC by Milan Zázrivec
Modified: 2012-09-21 09:20 UTC (History)
3 users (show)

Fixed In Version: spacewalk-setup-1.7.9-9
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2012-09-21 09:20:21 UTC
Target Upstream Version:


Attachments (Terms of Use)

Description Milan Zázrivec 2011-06-22 11:57:53 UTC
Description of problem:
Default AJP Proxy setup defined in /etc/tomcat6/server.xml says:

<Connector port="8009" protocol="AJP/1.3" redirectPort="8443"
URIEncoding="UTF-8" address="127.0.0.1" />

which will cause the connector to listen at an IPv4-mapped IPv6 address
::ffff:127.0.0.1:8009

Corresponding rewrite rule defined /etc/httpd/conf.d/zz-spacewalk-www.conf:

<IfModule proxy_ajp_module>
RewriteRule ^/rhn(.*) ajp://localhost:8009/rhn$1 [P]
RewriteRule ^(/.*\.(do|jsp)(\?.*)?)$ ajp://localhost:8009/$1 [P]
</IfModule>

In an IPv6 only environment Apache will resolve localhost as ::1 -> apache
will never be able to connect to tomcat -> java part of Satellite will
never work.

Version-Release number of selected component (if applicable):
spacewalk-setup-1.2.6-11

How reproducible:
Always

Steps to Reproduce:
1. Install Satellite 5.4.1 in an IPv6 only environment
2. Try to create first user in webui
3. Check /var/log/httpd/error_log
  
Actual results:
Lots of errors like the following:

[error] proxy: AJP: failed to make connection to backend: localhost
[error] (111)Connection refused: proxy: AJP: attempt to connect to [::1]:8009 
(*) failed

Apache is unable to connect to tomcat.

Expected results:
No errors like the above, Apache is able to connect to tomcat.

Additional info:
The straightforward fix would be to add the following line to server.xml:

<Connector port="8009" protocol="AJP/1.3" redirectPort="8443" 
URIEncoding="UTF-8" address="::1" /> 

The above fix is tested and is also required for a successful Satellite IPv6
installation and operation.

Comment 1 Milan Zázrivec 2011-10-07 09:18:42 UTC
Define AJP connector on [::1]:8009:

spacewalk.git master: e2fc2c1c119be41d1c90c5d265c03512dce69da4

Comment 5 Clifford Perry 2012-09-21 09:20:21 UTC
This issue is resolved with the release of RHN Satellite 5.5. 

As of September 20th 2012, RHN Satellite 5.5 has been generally available. 

Release Notes and other 5.5 documentation can be found here:

 https://access.redhat.com/knowledge/docs/Red_Hat_Network_Satellite/

The associated Errata for the 5.5 release are:

5.5 Satellite GA Errata
 - http://rhn.redhat.com/errata/RHEA-2012-1296.html

5.5 Upgrade Errata
 - http://rhn.redhat.com/errata/RHEA-2012-1298.html

5.5 RHN Proxy GA Errata
 - http://rhn.redhat.com/errata/RHEA-2012-1297.html

5.5 RHN Tools GA Errata
 - http://rhn.redhat.com/errata/RHEA-2012-1299.html

Regards,
Clifford
- Engineering Manager, Satellite


Note You need to log in before you can comment on or make changes to this bug.